package server

import (
	"context"
	"net/http"
	"sync"

	httpSwagger "bitbucket.org/_metalogic_/httptreemux-swagger"
	"bitbucket.org/_metalogic_/log"
	schemas "bitbucket.org/_metalogic_/schemas-svc"
	_ "bitbucket.org/_metalogic_/schemas-svc/docs" // docs is generated by Swag CLI, you have to import it.
	"github.com/dimfeld/httptreemux/v5"
)

// SchemaServer ...
type SchemaServer struct {
	server  *http.Server
	journal schemas.Validator
}

func StartSchemasServer(port, traceHeader string, validator schemas.Validator, wg *sync.WaitGroup) (srv *SchemaServer) {

	srv = &SchemaServer{
		server:  &http.Server{Addr: port, Handler: router(validator, traceHeader)},
		journal: validator,
	}

	// start the HTTP server
	go func() {
		defer wg.Done() // let main know we are done cleaning up

		// always returns error. ErrServerClosed on graceful close
		if err := srv.server.ListenAndServe(); err != http.ErrServerClosed {
			// unexpected error. port in use?
			log.Fatalf("ListenAndServe(): %v", err)
		}
	}()

	// returning reference so caller can call Shutdown()
	return srv
}

func (svc *SchemaServer) Shutdown(ctx context.Context) {
	if err := svc.server.Shutdown(ctx); err != nil {
		log.Fatal(err)
	}
	log.Warning("shutdown HTTP server")
}

// create the HTTP router for Service
func router(validator schemas.Validator, traceheader string) *httptreemux.TreeMux {
	// initialize HTTP router
	treemux := httptreemux.New()
	api := treemux.NewGroup("/schemas-api/v1")
	api.GET("/schemas", Schemas(validator))
	api.GET("/schemas/:schema", Schema(validator))
	api.POST("/validate", Validate(validator))
	// common endpoints
	api.GET("/admin/loglevel", LogLevel(validator))
	api.PUT("/admin/loglevel/:verbosity", SetLogLevel(validator))
	api.GET("/health", Health(validator))
	api.GET("/info", APIInfo(validator))
	api.GET("/openapi/*", httpSwagger.Handler(
		httpSwagger.URL("doc.json"), // The url pointing to API definition
		httpSwagger.DeepLinking(true),
		httpSwagger.DocExpansion("none"),
		httpSwagger.DomID("#swagger-ui")))
	return treemux
}
